#pragma once

#ifndef __WMAIN__
#define __WMAIN__

#include <Windows.h>

struct WMainClass {
	short Width{};
	short Height{};
	bool Windowed{ true };
};

class WMainProg {
private:
	HWND MainWnd{};
	MSG uMsg{ 0 };

	HINSTANCE hInst{};

public:
	int MainLoop();

	long long duration{};

public:
	WMainProg();
	~WMainProg();

	bool Create(WMainClass);
	virtual void wndproc(MSG uMsg) {}

	virtual void Loop() {}
	virtual void Start() {}

	HWND GetMainWnd() { return MainWnd; }
	MSG GetMsg() { return uMsg; }
};

#endif __WMAIN__